config/routes.rb
# frozen_string_literal: true
Rails.application.routes.draw do
  resources :cases

  # resources :registrations
  resources :committees do
    resources :registrations, only: :index
    resources :meetings do
      match :edit_agenda, via: :get
      match :generate_agenda, via: :get

      resources :registrations
      match :increment_max_candidates_number, via: :get
      match :decrement_max_candidates_number, via: :get
      match :approve, via: :get
    end
  end

  root 'home#index'
  match 'home/private_index' => 'home#private_index', via: :get

  match 'get_permitted_keywords' => 'home#permitted_keywords_get', via: :get
  match 'set_permitted_keywords' => 'home#permitted_keywords_set', via: :get

  # omniauth
  get '/auth/:provider/callback' => 'user_sessions#create'
  get '/auth/failure' => 'user_sessions#failure'
  get 'auth/autologin' => 'user_sessions#autologin'

  # Custom logout
  match '/logout', to: 'user_sessions#destroy', via: :all
end

app/models/meeting.rb
# frozen_string_literal: true
class Meeting < ApplicationRecord
  include Presentable
  # t.string   "name",                              null: false
  # t.integer  "committee_id",                      null: false
  # t.datetime "time_start"
  # t.datetime "time_end"
  # t.boolean  "approved"
  # t.datetime "created_at",                        null: false
  # t.datetime "updated_at",                        null: false
  # t.integer  "max_candidates_number", default: 1, null: false
  # t.text     "agenda"
  # t.integer  "registrations_count",   default: 0
  # t.index ["committee_id"], name: "index_meetings_on_committee_id", using: :btree

  # validations
  validates :name, :committee, :time_start, :time_end, presence: true
  validates :max_candidates_number, numericality: { greater_than: 0 }, presence: true
  validate :max_candidates
  validate :time_end_is_after_start

  # relations
  belongs_to :committee
  has_many :registrations, -> { order :priority_number }, dependent: :restrict_with_exception

  # scopes
  default_scope { order(:time_start) }
  scope :approved, -> { where(approved: true) }
  scope :unapproved, -> { where(approved: false) }

  scope :full, -> { where('max_candidates_number = registrations_count') }
  scope :free, -> { where.not('max_candidates_number = registrations_count') }
  scope :empty, -> { where('registrations_count = 0') }

  scope :future, -> { where('time_start > NOW()') }
  scope :past, -> { where('time_start <= NOW()') }

  # callbacs
  before_validation :set_max_candidates_number, on: :create

  # rest instance methods
  def registration_possible?
    (registrations.size < max_candidates_number) && future?
  end

  def increment_max_candidates_number
    update(max_candidates_number: max_candidates_number + 1)
  end

  def decrement_max_candidates_number
    update(max_candidates_number: max_candidates_number - 1)
  end

  def approve!
    update!(approved: true)
  end

  def generate_agenda
    agenda = registrations.includes(:case).map do |r|
      "#{r.priority_number}. #{r.case&.title || I18n.t(:no_case)}: #{r.title} " \
        "<p>#{r.description}<p>"
    end.join
    update(agenda: agenda)
  end

  def future?
    time_start > Time.zone.now
  end

  private

  def max_candidates
    return if registrations.size <= max_candidates_number
    errors.add(:max_candidates_number, I18n.t(:max_candidates_number_validation_error))
  end

  def set_max_candidates_number
    self.max_candidates_number = (duration_minutes / committee.minutes_per_candidate).to_i
  end

  def duration_minutes
    return 0 if time_start.blank? || time_end.blank?
    ((time_end - time_start) / 60).round
  end

  def time_end_is_after_start
    return if [time_start, time_end].any?(&:blank?)
    errors.add(:time_end, I18n.t(:must_be_after_beginning)) if time_start > time_end
  end
end

app/controllers/meetings_controller.rb
# frozen_string_literal: true
class MeetingsController < ApplicationController # rubocop:disable ClassLength
  before_action :set_meeting, only: %w(show edit update destroy increment_max_candidates_number
                                       decrement_max_candidates_number approve edit_agenda
                                       generate_agenda)
  before_action :set_committee
  skip_before_action :login_required, only: [:index, :show]
  before_action :initialize_presenter_helpers, only: :index

  # GET /meetings
  # GET /meetings.json
  def index
    permitted_keywords_get(params[:force_permitted_keyword_get])
    @meetings = if presenter_params.present?
                  @committee.meetings.presenter(presenter_params, @current_scopes)
                else
                  @committee.meetings.future
                end
    @meetings = @meetings.approved unless current_user.present?
  end

  # GET /meetings/1
  # GET /meetings/1.json
  def show; end

  # GET /meetings/new
  def new
    @meeting = Meeting.new
  end

  # GET /meetings/1/edit
  def edit; end

  # POST /meetings
  # POST /meetings.json
  def create
    @meeting = Meeting.new(meeting_params)
    @meeting.committee = @committee
    create_respond_to
  end

  # PATCH/PUT /meetings/1
  # PATCH/PUT /meetings/1.json
  def update
    respond_to do |format|
      if @meeting.update(meeting_params)
        format.html do
          redirect_to [@meeting.committee, @meeting],
                      notice: t(:meeting_successfully_updated)
        end
        format.json { render :show, status: :ok, location: @meeting }
      else
        format.html { render :edit }
        format.json { render json: @meeting.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /meetings/1
  # DELETE /meetings/1.json
  def destroy
    @meeting.destroy
    respond_to do |format|
      format.html do
        redirect_to committee_meetings_url,
                    notice: t(:meeting_successfully_destroyed)
      end
      format.json { head :no_content }
    end
  end

  def increment_max_candidates_number
    @meeting.increment_max_candidates_number
    change_max_candidates_number_redirect(t(:incremented))
  end

  def decrement_max_candidates_number
    @meeting.decrement_max_candidates_number
    change_max_candidates_number_redirect(t(:decremented))
  end

  def approve
    @meeting.approve!
    redirect_to committee_meetings_path(@committee), notice: t(:meeting_approved)
  end

  def edit_agenda; end

  def generate_agenda
    @meeting.generate_agenda
    redirect_to committee_meeting_edit_agenda_path(@committee, @meeting)
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_meeting
    @meeting = Meeting.find(params[:id] || params[:meeting_id])
    login_required unless current_user.present? || @meeting.approved?
  end

  def set_committee
    @committee = Committee.find(params[:committee_id])
  end

  def create_respond_to
    respond_to do |format|
      if @meeting.save
        format.html do
          redirect_to [@meeting.committee, @meeting],
                      notice: t(:meeting_successfully_created)
        end
        format.json { render :show, status: :created, location: @meeting }
      else
        format.html { render :new }
        format.json { render json: @meeting.errors, status: :unprocessable_entity }
      end
    end
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def meeting_params
    params.require(:meeting).permit(:name, :time_start, :time_end, :approved,
                                    :max_candidates_number, :agenda)
  end

  def presenter_params
    params.permit(scopes: [])
  end

  def initialize_presenter_helpers
    # when presentable concern will work with not only scopes we might need more variables here
    @current_scopes = []
  end

  def change_max_candidates_number_redirect(action)
    if @meeting.save
      redirect_to committee_meetings_path(@committee),
                  notice: t(:change_max_candidates_number_success, action: action,
                                                                   meeting_name: @meeting.name)
    else
      redirect_to committee_meetings_path(@committee),
                  alert: t(:change_max_candidates_number_failure, action: action,
                                                                  meeting_name: @meeting.name)
    end
  end
end

app/helpers/meetings_helper.rb
# frozen_string_literal: true
module MeetingsHelper
  def time_duration(time_start, time_end)
    "#{(time_end - time_start) / 3600}h"
  end

  def increment_max_candidates_number_link(meeting:)
    link_to committee_meeting_increment_max_candidates_number_path(@committee, meeting),
            class: 'btn btn-sm btn-success font-half', 'data-toggle': 'tooltip',
            title: t(:increment_max_candidates_number) do
      yield
    end
  end

  def decrement_max_candidates_number_link(meeting:)
    link_to committee_meeting_decrement_max_candidates_number_path(@committee, meeting),
            class: 'btn btn-sm btn-warning font-half', 'data-toggle': 'tooltip',
            title: t(:decrement_max_candidates_number) do
      yield
    end
  end

  def meeting_registrations_progress_text
    t(:busy_registrations,
      fraction: "#{@meeting.registrations.size} / #{@meeting.max_candidates_number}")
  end

  def filter_message
    msg = @current_scopes.map { |scope| t("mtgs.#{scope}").downcase }.to_sentence.presence
    " (#{msg || t('mtgs.normal').downcase})"
  end
end

app/views/meetings/_form.html.haml
= form_for [committee, meeting] do |f|
  - if meeting.errors.any?
    .container-fluid
      .card.card-outline-danger#error-explanation
        .card-block
          %h4
            = t('errors', count: meeting.errors.count)
            = t('error_message', count: meeting.errors.count)
          %ul.list-group
            - meeting.errors.full_messages.each do |msg|
              %li.list-group-item= msg
    .ls40

  .field.form-group
    = f.label :name
    = f.text_field :name, class: 'form-control'
  .field.form-group
    = f.label :time_start
    %br
    = f.text_field :time_start, class: 'd-none'
    .container
      .row
        = text_field_tag :day_start, meeting.time_start&.strftime('%Y/%m/%d'),
        class: 'form-control col-6', required: true
        = text_field_tag :hour_start, meeting.time_start&.strftime('%H:%M'),
        class: 'form-control col-6', required: true
  .field.form-group
    = f.label :time_end
    %br
    = f.text_field :time_end, class: 'd-none'
    .container
      .row
        = text_field_tag :day_end, meeting.time_end&.strftime('%Y/%m/%d'),
        class: 'form-control col-6', required: true
        = text_field_tag :hour_end, meeting.time_end&.strftime('%H:%M'),
        class: 'form-control col-6', required: true
  .field
    = f.label :approved
    = f.check_box :approved
  - unless action_name == 'new' || action_name == 'create'
    .field.form-group
      = f.label :max_candidates_number
      = f.text_field :max_candidates_number, class: 'form-control'
  .text-center.mt-3.mb-3#summary
  .actions.d-inline-block.float-right
    = f.submit t(:save), class: 'btn btn-success'

:coffee
  window.default_meeting_time = #{committee.default_meeting_time}

app/views/meetings/edit.html.haml
.row.second-bar
  = render template: 'shared/breadcrumbs',
  locals: { final_title: t(:edit_meeting) }

.col-md-5.offset-md-3
  = render 'form', meeting: @meeting, committee: @committee

  = link_to t(:back), committee_meetings_path(@committee),
  class: 'btn btn-secondary'

app/views/meetings/edit_agenda.html.haml
.row.second-bar
  = render template: 'shared/breadcrumbs'

= render 'shared/alerts'

= render 'shared/meeting_bar', meeting: @meeting

= form_for [@committee, @meeting] do |f|
  = f.trix_editor :agenda
  .ls20
  = f.submit t(:save), class: 'btn btn-primary btn-block'
.ls20

app/views/meetings/index.html.haml
.row.second-bar
  = render template: 'shared/breadcrumbs',
  locals: { final_title: t(:meetings) + filter_message }

  = render 'shared/additional_menu' do
    - if current_user.present?
      = link_to new_committee_meeting_path(@committee),
      class: 'nav-link btn btn-success', title: t(:new_meeting),
        'data-toggle': 'tooltip', 'data-placement': 'bottom' do
        %i.fa.fa-plus-square-o
        %span= t(:add)
    .btn-group#filter-menu
      %button.btn.btn-secondary.dropdown-toggle{ type: 'button',
      'data-toggle': 'dropdown', 'aria-haspopup': 'true',
      'aria-expanded': 'false' }
        %i.fa.fa-filter
        = t(:filter)
      .dropdown-menu
        = link_to committee_meetings_path(@committee.id),
        class: 'dropdown-item future_normal' do
          = t('mtgs.future_normal')
        = link_to committee_meetings_path(@committee.id,
        scopes: %i(future free), filter: 'future_free'),
        class: 'dropdown-item future_free' do
          = t('mtgs.future_free')
        - if current_user.present?
          = link_to committee_meetings_path(@committee.id,
          scopes: %i(future unapproved), filter: 'future_unapproved'),
          class: 'dropdown-item future_unapproved' do
            = t('mtgs.future_unapproved')
        = link_to committee_meetings_path(@committee.id, scopes: %i(all),
        filter: 'all'), class: 'dropdown-item all' do
          = t('mtgs.all')
        = link_to committee_meetings_path(@committee.id, scopes: %i(past),
        filter: 'past'), class: 'dropdown-item past' do
          = t('mtgs.past')

= render 'shared/alerts'

.row
  .col.table-responsive
    %table.table.meeting-table
      %thead
        %tr
          %th= t(:name)
          %th= t(:duration)
          %th.text-center= t(:registrations)
          %th.hidden-md-down= t(:time_start)
          %th.hidden-md-down= t(:time_end)
          - if current_user.present?
            %th.text-center= t(:approved)
          %th
          - if current_user.present?
            %th

      %tbody
        - @meetings.each do |meeting|
          %tr.show-on-hover-parent
            %td
              - if current_user.present?
                = link_to meeting.name, [meeting.committee, meeting]
              - else
                = meeting.name
            %td= time_duration(meeting.time_start, meeting.time_end)
            %td.text-center
              %div{ class: current_user.present? ? 'hide-on-hover' : nil }
                = meeting.registrations.size
                \/
                = meeting.max_candidates_number
              - if current_user.present?
                .btn-group.show-on-hover.inline
                  = decrement_max_candidates_number_link(meeting: meeting) do
                    %small
                      %i.fa.fa-minus
                  = meeting.max_candidates_number
                  = increment_max_candidates_number_link(meeting: meeting) do
                    %small
                      %i.fa.fa-plus
            %td.hidden-md-down= l(meeting.time_start, format: :short)
            %td.hidden-md-down= l(meeting.time_end, format: :time)
            - if current_user.present?
              %td.text-center
                - if meeting.approved?
                  %i.fa.fa-check-square-o
                - else
                  = link_to committee_meeting_approve_path(@committee,
                  meeting), class: 'color-black', 'data-toggle': 'tooltip',
                  title: t(:click_to_approve) do
                    %i.fa.fa-square-o
            %td
              - if meeting.approved? && meeting.registration_possible?
                = link_to t(:register),
                new_committee_meeting_registration_path(@committee.id,
                meeting.id), class: 'btn btn-sm btn-success'
            - if current_user.present?
              %td.position-relative
                .dropdown.show-on-hover
                  %button.btn-sm#more-dropdown-button{ type: 'button',
                  'data-toggle': 'dropdown', 'aria-haspopup': 'true',
                  'aria-expanded': 'false' }
                    = t(:more)
                  .dropdown-menu{ 'aria-labelledby': 'more-dropdown-button' }
                    = link_to t(:registrations), [@committee,
                    meeting, :registrations], class: 'dropdown-item'
                    = link_to edit_committee_meeting_path(meeting.committee,
                    meeting), class: 'dropdown-item' do
                      = t(:edit)
                    = link_to t(:destroy), [meeting.committee, meeting],
                    method: :delete, data: { confirm: t(:confirm_delete) },
                    class: 'dropdown-item'
      - if @meetings.empty?
        %tr
          %td
            = t(:no_meetings)
            &nbsp;
            = link_to new_committee_meeting_path(@committee) do
              = t(:add) + ' ' + t(:new_meeting).downcase

:coffee
  # opens dropdown for last two meeting above button
  trs = $('.meeting-table tbody tr')
  trs.slice(-2).addClass('dropup') if trs.size() > 6

  # makes filter menu item active
  $("#filter-menu .#{params[:filter] || 'future_normal'}").addClass 'active'

app/views/meetings/new.html.haml
.row.second-bar
  = render template: 'shared/breadcrumbs',
  locals: { final_title: t(:new_meeting) }

.col-md-5.offset-md-3
  = render 'form', meeting: @meeting, committee: @committee

  = link_to t(:back), committee_meetings_path(@committee),
  class: 'btn btn-secondary'

app/views/meetings/show.html.haml
.row.second-bar
  = render template: 'shared/breadcrumbs'

  - if current_user.present? || @meeting.registration_possible?
    = render 'shared/additional_menu' do
      - if current_user.present?
        = link_to committee_meeting_registrations_path(@committee,
        @meeting), class: 'btn btn-primary' do
          = t(:registrations)
      - if @meeting.registration_possible?
        = link_to new_committee_meeting_registration_path(@meeting.committee,
        @meeting), class: 'btn btn-success', title: t(:register),
        'data-toggle': 'tooltip', 'data-placement': 'bottom' do
          %i.fa.fa-plus-square-o
          %span.hidden-sm-up= t(:register)
      - if current_user.present?
        = link_to edit_committee_meeting_path(@meeting.committee, @meeting),
        class: 'btn btn-secondary', title: t(:edit_meeting),
        'data-toggle': 'tooltip', 'data-placement': 'bottom' do
          %i.fa.fa-edit
          %span.hidden-sm-up= t(:edit)
        = link_to [@meeting.committee, @meeting],
        method: :delete, data: { confirm: t(:confirm_delete) },
        class: 'btn btn-warning', title: t(:delete_meeting),
        'data-toggle': 'tooltip', 'data-placement': 'bottom',
        'data-offset': '0 20' do
          %i.fa.fa-trash-o
          %span.hidden-sm-up= t(:delete)

= render 'shared/alerts'

= render 'shared/meeting_bar', meeting: @meeting

- if current_user.present?
  .row
    .col-md-6.offset-md-3
      %h3= t(:agenda)
      - if @meeting.agenda.blank?
        %p= t(:no_agenda)
        .btn-group
          = link_to t(:generate),
          committee_meeting_generate_agenda_path(@committee,
          @meeting), class: 'btn btn-secondary'
          = link_to t(:edit), committee_meeting_edit_agenda_path(@committee,
          @meeting), class: 'btn btn-secondary'
      - else
        = link_to t(:edit),
        committee_meeting_edit_agenda_path(@committee,
        @meeting), class: 'btn btn-secondary'
        .ls20
        -# rubocop:disable Rails/OutputSafety
        = raw sanitize @meeting.agenda, attributes: %w(id class href),
        tags: %w(strong em a br ul ol li del h1 pre div)
        -# rubocop:enable Rails/OutputSafety